/**
 * 	@file CSV.java
 * 	@author Andy Small
 * 	@version 2.0
 * 	@brief Reads a .csv file of passed filename, checks and removes errors
 * 	@date 18/3/2013
 *	@see GUI
 *
 *	This class is given a filename, from a filechooser, and imports the data
 *	from that csv file
 */
 

 
import java.io.File;
import java.io.IOException;
import java.util.Scanner;


public class CSV {	
	private GUI m_Host;

	/**
	* Construct a CSV
	*
	* @param host is the instance of the main GUI to be shared with all classes
	* 
	*/
	public CSV(GUI host){
		m_Host = host;
	}
	
	/**
	* Import the data from a CSV File
	*
	* @param CSVFile is the RandomAccessFile which was selected by the user
	*
	*/
	public void ImportCSVFile(File CSVFile){	
		try {
			int lineCount = 0;
			int wordCount = 0;
			Scanner lineReader = new Scanner(CSVFile);
            while (lineReader.hasNextLine()) {
                String line = lineReader.nextLine();
				lineCount++;
            }
			
			lineReader = new Scanner(CSVFile);
			String firstLine = lineReader.nextLine().replace(',', ' ');
			Scanner wordReader = new Scanner(firstLine);
			while (wordReader.hasNext()){	
				wordReader.next();
				wordCount++;
			}
		
			String[][] dataContents = new String[lineCount][wordCount];
			String[] dataHeadings = new String[wordCount];
			
			lineCount = 0;
			Scanner fileReader = new Scanner(CSVFile);
			while (fileReader.hasNextLine()) {
                String line = fileReader.nextLine();
				line = line.replace(",", " ");
				Scanner readWords = new Scanner(line);	
				if (lineCount == 0){
					for (int i = 0; i < wordCount; i++){
						dataHeadings[i] = readWords.next();
					}
				} else {
					for (int j = 0; j < wordCount; j++){
						dataContents[lineCount-1][j] = readWords.next();
					}
				}	
				lineCount++;
			}
			m_Host.SetTableHeadings(dataHeadings);
			m_Host.SetTableData(dataContents);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	public void ImportCSVFileLeft(File CSVFile){	
		try {
			int lineCount = 0;
			int wordCount = 0;
			Scanner lineReader = new Scanner(CSVFile);
            while (lineReader.hasNextLine()) {
                String line = lineReader.nextLine();
				lineCount++;
            }
			
			lineReader = new Scanner(CSVFile);
			String firstLine = lineReader.nextLine().replace(',', ' ');
			Scanner wordReader = new Scanner(firstLine);
			while (wordReader.hasNext()){	
				wordReader.next();
				wordCount++;
			}
		
			String[][] dataContents = new String[lineCount][wordCount];
			String[] dataHeadings = new String[wordCount];
			
			lineCount = 0;
			Scanner fileReader = new Scanner(CSVFile);
			while (fileReader.hasNextLine()) {
                String line = fileReader.nextLine();
				line = line.replace(",", " ");
				Scanner readWords = new Scanner(line);	
				if (lineCount == 0){
					for (int i = 0; i < wordCount; i++){
						dataHeadings[i] = readWords.next();
					}
				} else {
					for (int j = 0; j < wordCount; j++){
						dataContents[lineCount-1][j] = readWords.next();
					}
				}	
				lineCount++;
			}
			m_Host.SetTableHeadingsLeft(dataHeadings);
			m_Host.SetTableDataLeft(dataContents);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}